********************************************************************************
********************************************************************************
*************         政府环境信息披露提升环境治理成效       ******************* 
********************************************************************************
********************************************************************************

*******************************************************************************
***                             描述性统计 
*******************************************************************************

 gen did = Disclose×Risk  /*因xtlogit无法进行i.Disclose##i.Risk，故单独生成 */

***描述性统计
 logout, save(Description) word replace: tabstat ///
          Discharge did ///
		  Lnpgdp Struct Urban Lnasset Lev Roa PPE Lndirect First Dual Indep State HHI,
          stat(n mean max median min sd) col(s) f(%6.3f)  
 
 
 ****************
 logout, save(Difference) word replace: ///
      ttable2 Discharge did Lnpgdp Struct Urban Lnasset Lev Roa PPE Lndirect First Dual Indep State HHI, by(Disclose)
 

 *******************************************************************************
 ****                            基准回归 
 *******************************************************************************

 global Control "Lnpgdp Struct Urban Lnasset Lev Roa PPE Lndirect First Dual Indep State HHI" 
 
 xtlogit Isenv Disclose Risk did i.year, vce(cluster stkcd)  
 estimates store Model1
 xtlogit Isenv Disclose Risk did $Control i.year, vce(cluster stkcd) 
 estimates store Model2
 reghdfe Discharge i.Disclose##i.Risk, absorb(stkcd year) vce(cluster stkcd)
 estimates store Model3
 reghdfe Discharge  i.Disclose##i.Risk $Control, absorb(stkcd year) vce(cluster stkcd)
 estimates store Model4
 
 ****  竞争性分析
 gen COopen =0
 global pcit 北京市 天津市 上海市  重庆市 湖北省 广东省

 foreach v of global pcit {
    replace COopen = 1 if prvn=="`v'" & year >= 2013
 }
 reghdfe Discharge i.Disclose##i.Risk COopen $Control, absorb(stkcd year) vce(cluster stkcd)
 estimates store Model5
 

 *******************************************************************************
 ****                           平行趋势检验
 *******************************************************************************

 gen distance = year - pyear   /* pyear为实施年份 */
 tab distance, missing
*  考虑样本稀疏的问题
 replace distance = -3 if distance < -3 & !missing(distance)
 replace distance = 5 if distance > 5 & !missing(distance)
 tab distance 
 
 ********* 生成变量
 forvalues i = 3(-1)1 {   
  gen pre`i' = (distance == -`i' & Risk == 1) 
 }
 gen current = (distance == 0 & Risk == 1)  
 forvalues j = 1(1)5 {
  gen after`j' = (distance == `j' & Risk == 1)  
 }

 ********* 实证回归
 drop pre1
 reghdfe Discharge  pre* current after*  $Control, absorb(stkcd year) vce(cluster stkcd)
/*注：论文中的平行趋势图（图1）是基于该回归结果用R绘制的)*/
 
 *******************************************************************************
 ****                             安慰剂检验
 *******************************************************************************
 
 cls
 reghdfe Discharge Disclose Risk did Lnpgdp Struct Urban Lnasset Lev Roa PPE Lndirect First Dual Indep State HHI, absorb(stkcd year) vce(cluster stkcd)
 
 *****************
  permute Disclose beta = _b[did] se = _se[did] df = e(df_r), ///
    reps(500)  seed(123) saving("Disclose500.dta"): ///
    reghdfe Discharge Disclose Risk did Lnpgdp Struct Urban Lnasset Lev Roa PPE Lndirect First Dual Indep State HHI, absorb(stkcd year) vce(cluster stkcd)
 

 *****************
  permute Disclose beta = _b[did] se = _se[did] df = e(df_r), ///
  reps(1000)  seed(123) saving("Disclose1000.dta"): ///
  reghdfe Discharge Disclose Risk did Lnpgdp Struct Urban Lnasset Lev Roa PPE Lndirect First Dual Indep State HHI, absorb(stkcd year) vce(cluster stkcd)
	

 *****************
  permute did beta = _b[did] se = _se[did] df = e(df_r), ///
      reps(500)  seed(123) saving("did500.dta"): ///
     reghdfe Discharge  Disclose Risk did Lnpgdp Struct Urban Lnasset Lev Roa PPE Lndirect First Dual Indep State HHI, absorb(stkcd year) vce(cluster stkcd)

    *****************
  permute did beta = _b[did] se = _se[did] df = e(df_r), ///
      reps(1000)  seed(123) saving("did1000.dta"): ///
     reghdfe Discharge  Disclose Risk did Lnpgdp Struct Urban Lnasset Lev Roa PPE Lndirect First Dual Indep State HHI, absorb(stkcd year) vce(cluster stkcd)
 
 /*注：论文中的安慰剂检验图（图2）是用R对上述结果进行绘制得到的)*/ 
 	
 *******************************************************************************
 ****                            内生性处理
 *******************************************************************************
 
 * 1. 工具变量法 
 ivreghdfe Discharge (did = TyNews) Disclose Risk $Control, absorb(stkcd year) 
 estimates store Model1
 
 
*  2. Heckman模型 
 xtprobit did Lnpgdp Struct Urban Lnasset Lev Roa PPE Lndirect First Dual Indep State HHI year*, re vce(cluster stkcd)
 predict w, xb
 gen IMR = normalden(w)/normal(w)
 reghdfe Discharge i.Disclose##i.Risk IMR $Control, absorb(stkcd year) vce(cluster stkcd)
 estimates store Model2

 
*  3.PSM+DID  
preserve
set seed 5920128 
gen tmp=runiform()
sort tmp
psmatch2 Disclose Lnasset Lev Roa PPE Lndirect First Dual Indep State HHI, out(Discharge) kernel ate logit common 
drop if _weight==.
 reghdfe Discharge i.Disclose##i.Risk $Control, absorb(stkcd year) vce(cluster stkcd)
 estimates store Model3
restore


 *******************************************************************************
 ****                          其他稳健性检验
 *******************************************************************************
 
*  4.替换变量	 
 reghdfe Envm i.Disclose##i.Risk $Control, absorb(stkcd year) vce(cluster stkcd)
 estimates store Model4
 
*  5.替换模型
 xttobit Discharge i.Disclose##i.Risk  $Control year*, vce(bootstrap)
  estimates store Model5
 
*  6.联合固定效应
 encode ind, gen(indid)
 encode prvn, gen(prvnid)
 reghdfe Discharge i.Disclose##i.Risk $Control, absorb(stkcd year indid#year prvnid#year) vce(cluster stkcd)
 estimates store Model6
 
*  7.考虑重要事件的扰动
 preserve
 drop if pftn=="深圳市" &  year == 2011
 drop if pftn=="北京市" &  year == 2014
 drop if pftn=="杭州市" &  year == 2016
 reghdfe Discharge i.Disclose##i.Risk Lnpgdp Struct Urban Lnasset Lev Roa PPE Lndirect First Dual Indep State HHI, absorb(stkcd year) vce(cluster stkcd)
   estimates store Model7
 restore
 
 
 *******************************************************************************
 ****                          机制分析
 *******************************************************************************
 
 reghdfe Lawf i.Disclose##i.Risk $Control, absorb(stkcd year) vce(cluster stkcd)
 estimates store Model1
 reghdfe Discharge  i.Disclose##i.Risk##c.Lawf $Control, absorb(stkcd year) vce(cluster stkcd)
 estimates store Model2
 reghdfe Public i.Disclose##i.Risk $Control, absorb(stkcd year) vce(cluster stkcd)
 estimates store Model3
 reghdfe  Discharge  i.Disclose##i.Risk##c.Public $Control, absorb(stkcd year) vce(cluster stkcd)
 estimates store Model4


 *******************************************************************************
 ****                         调节效应分析
 *******************************************************************************
 
 ****** 财政压力
 reghdfe Discharge  i.Disclose##i.Risk##c.Mpre $Control, absorb(stkcd year) vce(cluster stkcd)
 estimates store Model1

 ****** 环保补助
 reghdfe Discharge  i.Disclose##i.Risk##c.Finaid $Control, absorb(stkcd year) vce(cluster stkcd)
 estimates store Model2

 
 *******************************************************************************
 ****                         影响效应分析
 *******************************************************************************

 ****** 绿色创新
 reghdfe Lnpatent Influen $Control, absorb(stkcd year) vce(cluster stkcd)
 estimates store Model1
 reghdfe Lnvig Influen $Control, absorb(stkcd year) vce(cluster stkcd)
 estimates store Model2
 ****** 全要素生产率
 reghdfe Lp Influen $Control, absorb(stkcd year) vce(cluster stkcd)
 estimates store Model3
 ****** 财务绩效
 reghdfe Roe Influen $Control, absorb(stkcd year) vce(cluster stkcd)
 estimates store Model4
 reghdfe TobinQ Influen $Control, absorb(stkcd year) vce(cluster stkcd)
 estimates store Model5
 

 
 				
 